// This file tests that the VM's function command correctly
// establishes the function's local segment.
//
// The translator should NOT emit bootstrap code for this test.
//
// After translating Function.vm, open Function.asm in an editor and 
// manually confirm:
//
//     1) that the function's entry point label, (Function.func)
//        is the first line of Hack assembly.
//
//     2) that the VM label statement is translated to the Hack
//        assembly label statement (Function.func$HERE)

load Function.asm,
output-file Function.out,
compare-to Function.cmp,
output-list RAM[0]%D1.6.1 RAM[256]%D1.6.1 RAM[257]%D1.6.1 
            RAM[258]%D1.6.1 RAM[259]%D1.6.1;

// Set SP and locations where the local segement will be established.

set RAM[0] 256,    // SP
set RAM[256] -1,   // Callee's LCL 0
set RAM[257] -1,   // Callee's LCL 1
set RAM[258] -1,   // Callee's LCL 2
set RAM[259] -1,   // Should not change.

repeat 100 {
  ticktock;
}

output;
