// This file tests that the VM's return command correctly restores the
// caller's environment, that the callee's return value is on the top of
// the stack, and that control is returned to the caller.
//
// The translator should NOT emit bootstrap code for this test.
//
// After running this test, manually verify that the PC's value is 512 or
// 513. I.e, that the CPU Emulator has actually returned to the simulated
// caller.

load Return.asm,
output-file Return.out,
compare-to Return.cmp,
output-list RAM[0]%D1.6.1 RAM[1]%D1.6.1 RAM[2]%D1.6.1
             RAM[3]%D1.6.1 RAM[4]%D1.6.1 RAM[5]%D1.6.1
             RAM[256]%D1.6.1;

// Set virtual registers.

set RAM[0] 265,    // SP
set RAM[1] 263,    // LCL
set RAM[2] 256,    // ARG
set RAM[3] -1,     // THIS
set RAM[4] -1,     // THAT
set RAM[5] -1,     // TMP[0]; should not change

// Set the activation frame.

set RAM[256] 1,      // Callee's ARG 0
set RAM[257] 2,      // Callee's ARG 1
set RAM[258] 512,    // Return address
set RAM[259] 3,      // Saved LCL segment register
set RAM[260] 4,      // Saved ARG 
set RAM[261] 5,      // Saved THIS
set RAM[262] 6,      // Saved THAT
set RAM[263] 7,      // Callee's LCL 0
set RAM[264] 42,     // Return value

// Set return target code for simulated caller.

set ROM[512] %X0200,    // @512
set ROM[513] %XEA87,    // 0;JMP

repeat 100 {
  ticktock;
}

output;
